/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
var __webpack_exports__ = {};
/*!****************************************************!*\
  !*** ./src/js/pro/admin/treweler-custom-fields.js ***!
  \****************************************************/


const {
  __
} = wp.i18n;

class TWER_CUSTOM_FIELDS {
  toggleRowByValue($rows, value, event) {
    switch (value) {
      case 'link':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_text', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_link' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'button':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_text', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_button' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'text':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_text' === row.dataset.rowId) {
            const isChecked = this.$checkboxDisplayAsTitle.checked;

            if (isChecked) {
              if (!row.contains(this.$inputTextNew)) {
                row.classList.remove('d-none');
              } else {
                row.classList.add('d-none');
              }
            } else {
              row.classList.remove('d-none');
            }

            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'multiselect':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_text', 'custom_field_true_false', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_multiselect' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'html':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_multiselect', 'custom_field_text', 'custom_field_true_false', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_html' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                e.value = '';
              });
            }
          }
        });
        break;

      case 'true_false':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_text', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_true_false' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'number':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_text'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_number' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'category':
        $rows.forEach((row, index) => {
          if (['custom_field_number', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_email', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_text'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_category' === row.dataset.rowId) {
            const $categoryStyleSelect = document.getElementsByClassName('js-category-style')[0];

            if ($categoryStyleSelect.value === 'tags') {
              if (!row.contains(document.getElementById('custom_field_category_size'))) {
                row.classList.remove('d-none');
              } else {
                row.classList.add('d-none');
              }
            } else {
              row.classList.remove('d-none');
            }

            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'email':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_text', 'custom_field_phone', 'custom_field_separator', 'custom_field_button', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_email' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'phone':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_text', 'custom_field_email', 'custom_field_separator', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_phone' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'separator':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_text', 'custom_field_email', 'custom_field_phone', 'custom_field_button', 'custom_field_line', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_separator' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;

      case 'line':
        $rows.forEach((row, index) => {
          if (['custom_field_category', 'custom_field_html', 'custom_field_multiselect', 'custom_field_true_false', 'custom_field_link', 'custom_field_text', 'custom_field_email', 'custom_field_phone', 'custom_field_button', 'custom_field_separator', 'custom_field_number'].includes(row.dataset.rowId)) {
            row.classList.add('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.setAttribute('disabled', ''));
          } else if ('custom_field_line' === row.dataset.rowId) {
            row.classList.remove('d-none');
            Array.from(row.querySelectorAll('input, textarea, select')).forEach(e => e.removeAttribute('disabled'));

            if (event === 'change') {
              Array.from(row.querySelectorAll('input:not([type="checkbox"]):not([type="hidden"]), textarea, select')).forEach(function (e) {
                if (e.tagName.toLowerCase() === 'select') {} else {
                  e.value = '';
                }
              });
            }
          }
        });
        break;
    }

    $rows.forEach((row, index) => {
      if ('custom_field_show' === row.dataset.rowId) {
        if ('separator' === value || 'button' === value || 'line' === value || 'true_false' === value) {
          row.classList.add('d-none');
        } else {
          row.classList.remove('d-none');
        }

        if (('number' === value || 'true_false' === value) && event === 'change') {
          row.querySelectorAll('#custom_field_show')[0].checked = true;
        } else if ('number' !== value && 'true_false' !== value && event === 'change') {
          row.querySelectorAll('#custom_field_show')[0].checked = false;
        }
      }

      if ('custom_field_name_width' === row.dataset.rowId) {
        if (('text' === value || 'link' === value || 'phone' === value || 'email' === value || 'number' === value) && this.$showFieldName.checked) {
          row.classList.remove('d-none');
        } else {
          row.classList.add('d-none');
        }

        if (event === 'change') {
          document.getElementById('custom_field_name_width').value = '';
        }
      }
    });
  }

  toggleRowHandlers() {
    const $fieldTypes = document.querySelectorAll('select.js-custom-fields-type');
    const $fieldRows = document.querySelectorAll('.js-twer-row');

    if ($fieldTypes.length > 0 && $fieldRows.length > 0) {
      $fieldTypes.forEach((select, index) => {
        this.toggleRowByValue($fieldRows, select.value, 'load');
        select.addEventListener('change', e => {
          this.toggleRowByValue($fieldRows, e.target.value, 'change');
        });
      });
    }

    const toggleCategoriesRows = $select => {
      const $currentRow = $select.closest('.js-twer-row');
      const $nextRow = $currentRow.nextElementSibling;

      if ($fieldTypes[0].value === 'category') {
        if ($select.value === 'tags') {
          $nextRow.classList.add('d-none');
        } else {
          $nextRow.classList.remove('d-none');
        }
      } else {
        $nextRow.classList.add('d-none');
      }
    };

    const $categoryStyleSelect = document.getElementsByClassName('js-category-style')[0];
    toggleCategoriesRows($categoryStyleSelect);
    $categoryStyleSelect.addEventListener('change', e => {
      toggleCategoriesRows(e.target);
    });
  }

  constructor(props) {
    // Init JQuery
    this.$ = $ = props;
    this.$checkboxDisplayAsTitle = document.getElementById('custom_field_text_showTitle');
    this.$showFieldName = document.getElementById('custom_field_show');
    this.$inputTextOld = document.getElementsByClassName('js-twer-old-text-input')[0];
    this.$inputTextNew = document.getElementsByClassName('js-twer-new-text-input')[0];
    this.$inputTextNewRow = this.$inputTextNew.closest('.js-twer-row');
    this.$inputNameWidth = document.getElementsByClassName('js-field-name-width')[0];
    this.$rowFieldNameWidth = this.$inputNameWidth.closest('.js-twer-row');
    this.toggleRowHandlers();
    const colorPicker = $('.color-picker'); // Universal init color pickers

    $(document).on('click', '.js-twer-colorpicker .btn', function (event) {
      event.preventDefault();
      const $colorPicker = $(this);
      const $colorPickerCell = $colorPicker.children('.js-twer-colorpicker-cell');
      const $colorPickerWrap = $colorPicker.closest('.js-twer-colorpicker');
      const $palette = $colorPickerWrap.find('.js-twer-colorpicker-palette');
      const $colorInput = $colorPickerWrap.find('.js-twer-colorpicker-color');
      const $colorDefaultInput = $colorPickerWrap.find('.js-twer-colorpicker-custom-color');
      $colorPicker.closest('.js-twer-row').siblings().find('.a-color-picker').remove();

      if ($palette.find('.a-color-picker').length === 0) {
        //console.log($colorInput.val());
        TWER_HELPERS.AColorPicker.from($palette[0], {
          showRGB: false,
          showHSL: false,
          paletteEditable: true,
          color: $colorInput.val()
        }).on('change', (picker, color) => {
          $colorPickerCell.css('background-color', picker.color);
          $colorInput.val(picker.color);
          $palette.attr('acp-color', picker.color);
        }).on('coloradd', (picker, color) => {
          let cca = $colorDefaultInput;

          if (cca.val().indexOf('|' + color) === -1) {
            cca.val(cca.val() + '|' + color);
            jQuery.ajax({
              url: twer_ajax.url,
              type: 'POST',
              data: {
                action: 'treweler_add_colorpicker_custom_color',
                cust_color: cca.val()
              },
              success: function (response) {
                let defaultCP = $palette.attr('data-default-palette');
                $palette.attr('acp-palette', defaultCP + '' + response);
                $palette.attr('acp-palette', defaultCP + '' + response);
                colorPicker.attr('acp-palette', defaultCP + '' + response);
              }
            });
          }
        }).on('colorremove', (picker, color) => {
          let ccr = $colorDefaultInput;

          if (ccr.val().indexOf('|' + color) !== -1) {
            let sc = ccr.val().replace('|' + color, '');
            ccr.val(sc);
            jQuery.ajax({
              url: twer_ajax.url,
              type: 'POST',
              data: {
                action: 'treweler_add_colorpicker_custom_color',
                cust_color: ccr.val()
              },
              success: function (response) {
                let defaultCP = $palette.attr('data-default-palette');
                $palette.attr('acp-palette', defaultCP + '' + response);
              }
            });
          }
        });
      } else {
        $palette.find('.a-color-picker').remove();
      }
    });
    $('.js-twer-colorpicker-palette').on('click', function (event) {
      event.stopPropagation();
    });
    $(document).on('click', function (event) {
      if (!$(event.target).closest('.js-twer-colorpicker').length > 0) {
        $('.js-twer-colorpicker-palette').find('.a-color-picker').remove();
      }
    });

    if (this.$inputTextOld.value) {
      this.$inputTextNew.value = this.$inputTextOld.value;
    }

    this.$showFieldName.addEventListener('change', e => {
      const isChecked = e.target.checked;
      const value = document.querySelectorAll('select.js-custom-fields-type')[0].value;

      if (('text' === value || 'link' === value || 'phone' === value || 'email' === value || 'number' === value) && isChecked) {
        this.$rowFieldNameWidth.classList.remove('d-none');
      } else {
        this.$rowFieldNameWidth.classList.add('d-none');
      }
    });
    this.$checkboxDisplayAsTitle.addEventListener('change', e => {
      const isChecked = e.target.checked;

      if (isChecked) {
        this.$inputTextNewRow.classList.add('d-none');
      } else {
        this.$inputTextNewRow.classList.remove('d-none');
      }
    });
  }

} //;(function(){


window.addEventListener('DOMContentLoaded', () => {
  new TWER_CUSTOM_FIELDS(jQuery);
}); //})();
/******/ })()
;
//# sourceMappingURL=treweler-custom-fields.js.map